<?php
/**
 * Plugin Name: Marvinerp EU Vat
 * Plugin URI: 
 * Description: Add Europe VAT Number to Checkout and confirm it
 * Version: 1.0
  * Requires at least: 5.2
 * Requires PHP:      7.2
 * Author:	ponto25
 * Author URI:	https://www.ponto25.com/
 * Text Domain: 
 * WC version: 4.5.2
 * License:           GPLv2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 */


// MVPN Marvinerp Vat Plugin Wordpress

function MVPN_myplugin_activate() {}        
function MVPN_myplugin_desactivate() {}

register_activation_hook( __FILE__, 'MVPN_myplugin_activate' );
register_deactivation_hook( __FILE__, 'MVPN_myplugin_desactivate' );
    
    if (!defined('ABSPATH'))exit; // Exit if accessed directly
    if (!defined('MARVIN_VAT_DIR')) {define('MARVIN_VAT_DIR', __DIR__);}
    if (!defined('MARVIN_VAT_FILE')) {define('MARVIN_VAT_FILE', __FILE__);}
    if (!defined('MARVIN_VAT_ASSETS')) {define('MARVIN_VAT_ASSETS', plugin_dir_url(__FILE__) . 'assets/');}
    
    add_action('admin_menu', 'MVPN_my_menu');
    function MVPN_my_menu() {
        add_submenu_page( 'tools.php', 'marvin erp VAT EU', 'marvin erp VAT EU', 'manage_options', 'VAT_Settings', 'MVPN_Settings_Page_Confirmation' ); 
    }
   
    function MVPN_Settings_Page_Confirmation(){
        include_once  MARVIN_VAT_DIR."/Settings.php";
        wp_enqueue_style('Bootstrap', plugins_url('/assets/bootstrap.min.css', MARVIN_VAT_FILE));
        wp_enqueue_style('BootstrapMap', plugins_url('/assets/bootstrap.min.css.map', MARVIN_VAT_FILE));
        wp_enqueue_style('style', plugins_url('/assets/style.css', MARVIN_VAT_FILE));
        include_once  MARVIN_VAT_DIR."/assets/home.php"; 
    }


    $action = isset($_REQUEST['action']) ? sanitize_text_field(trim($_REQUEST['action'])) : '';
    if ($action === 'Guardar_NIF') {
        
        $path_setting_file = (dirname(__FILE__) . "/Settings.php");
        $myfile = fopen($path_setting_file, "w") or die("Unable to open file!");
        if($_POST['Value'] == "1"){
            $txt="
            <?php
            //Validate the NIF check digit?
            add_filter( 'MVPN_woocommerce_nif_field_validate', '__return_true' );
            Define('MVPN_NIF_ON',true);
            
            ?>";
        }
        else{
            $txt="
            <?php
            //Validate the NIF check digit?
            add_filter( 'MVPN_woocommerce_nif_field_validate', '__return_false' );
            Define('MVPN_NIF_ON',false);
            ?>";
        }        
        fwrite($myfile, $txt);
        fclose($myfile);
    }


/**
 * Check if WooCommerce is active
 **/
	function MVPN_is_woocommerce_activated() {
        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        if ( is_plugin_active( 'woocommerce/woocommerce.php') )
            return true;
        else
            wp_die(esc_html__('Requires WooCommerce 3.0.0 or above.', 'marvinerp-pt'));
            return false; 
    }

if (MVPN_is_woocommerce_activated()) {
    

    //Adiciona o Nif aos Billing Fields
	add_filter( 'woocommerce_billing_fields', 'MVPN_woocommerce_nif_billing_fields', 10, 2 );
	function MVPN_woocommerce_nif_billing_fields( $fields, $country ) {
		$fields['billing_vat'] = array(
			'type'			=>	'text',
			'label'			=> 'EU VAT (Portugal: NIF)',
			'placeholder'	=> 'European ID VAT Number',
			'class'			=> array( 'form-row-wide' ), //Should be an option (?)
			'required'		=> true,
			'clear'			=> true, //Should be an option (?)
			'autocomplete'	=> 'on',
			'priority'		=> 120, //WooCommerce should order by this parameter but it doesn't seem to be doing so
            'validate'		=> array( 'Vat'), //Does nothing, actually - Validation is down there on the 'woocommerce_checkout_process' action
        );
		return $fields;
	}

        //Validation - Checkout
        add_action( 'woocommerce_checkout_process', 'MVPN_add_info_checkout_process' );
        function MVPN_add_info_checkout_process() {
                $get_billing_country = WC()->customer->get_billing_country();
                $countries = new WC_Countries();
                $billing_vat = wc_clean( isset( $_POST['billing_vat'] ) ? $_POST['billing_vat'] : '' );
                if(MVPN_NIF_ON){
                    if ( (MVPN_woocommerce_valida_nif( $billing_vat, $get_billing_country ) ||  trim( $billing_vat ) == '')) { 
                        //If the field is NOT required and it's empty, we shouldn't validate it
                            //OK
                        } else {
                            wc_add_notice('NIF Incorreto','error');
                        }
                }    
        }
        //Validation - Save address
        add_action( 'woocommerce_after_save_address_validation', 'MVPN_save_nif_after_address_validation', 10, 3 );
        function MVPN_save_nif_after_address_validation( $user_id, $load_address, $address ) {
            if ( $load_address == 'billing' ) {
                    $country = wc_clean( isset( $_POST['billing_country'] ) ? $_POST['billing_country'] : '' );
                    $billing_vat = wc_clean( isset( $_POST['billing_vat'] ) ? $_POST['billing_vat'] : '' );
                    if(MVPN_NIF_ON){
                        if ( (MVPN_woocommerce_valida_nif( $billing_vat, $get_billing_country ) ||  trim( $billing_vat ) == '') ) { 
                            //If the field is NOT required and it's empty, we shouldn't validate it
                            //OK
                            } else {
                                wc_add_notice('Nif Incorreto','error');
                            }
                        }
            }
        }
    

        //Add field to the admin user edit screen
        add_action( 'woocommerce_customer_meta_fields', 'MVPN_add_field_customer_meta_fields' );
        function MVPN_add_field_customer_meta_fields( $show_fields ) {
            if ( isset( $show_fields['billing'] ) && is_array( $show_fields['billing']['fields'] ) ) {
                $show_fields['billing']['fields']['billing_vat'] = array(
                    'label' => 'European ID VAT Number - (Portugal: NIF)',
                    'description' => 'European VAT identification number');
            }
            return $show_fields;
        }
    
        //Add field to customer details on the Thank You page
        add_action( 'woocommerce_order_details_after_customer_details', 'MVPN_add_Field_to_order_details' );
        function MVPN_add_Field_to_order_details( $order ) {
            $billing_country = $order->get_billing_country();
            $billing_vat =$order->get_meta( '_billing_vat' );
            if ($billing_vat) {
                ?>
                <tr>
                    <th><b><?php echo "European ID VAT Number - (Portugal: NIF)  " ?>:</b></th>
                    <td><?php echo " ".esc_html( $billing_vat ); ?></td>
                </tr>
                <?php
            }
    }
        
        function MVPN_woocommerce_valida_nif( $nif, $customer_country) {
            try{
                // Initialize WS with the WSDL
                $client = new \SoapClient("https://ec.europa.eu/taxation_customs/tin/checkTinService.wsdl");
                // Set request params
                $params = array("countryCode" => trim($customer_country),"tinNumber"   => trim($nif),);
                //Invoke WS method (checkTin) with the request params 
                $response = $client->__soapCall("checkTin", array($params));			                            
                // Print WS response, aceita se é valido ou a estrutura é valida
                if($response->validStructure || $response->validSyntax )
                    return true;
                else{
                    return false;
                }

            }catch(Error $error){
                if( $customer_country =="PT"){
                    $nif = trim( $nif );
                    //Verificamos se é numérico e tem comprimento 9
                    if ( !is_numeric( $nif ) || strlen( $nif ) != 9 ) {return false;}
                    else {
                        $nifSplit = str_split( $nif );
                        //O primeiro digíto tem de ser 1, 2, 5, 6, 8 ou 9
                        //Ou não, se optarmos por ignorar esta "regra"
                        if (in_array( $nifSplit[0], array( 1, 2, 5, 6, 8, 9 ) )||$ignoreFirst) {
                            $checkDigit=0;//Calculamos o dígito de controlo
                            for( $i=0; $i<8; $i++ ) {$checkDigit += $nifSplit[$i] * ( 10-$i-1 );}
                            $checkDigit = 11 - ( $checkDigit % 11 );
                            //Se der 10 então o dígito de controlo tem de ser 0
                            if( $checkDigit >= 10 ) $checkDigit = 0;
                            //Comparamos com o último dígito
                                if ( $checkDigit == $nifSplit[8] ) {return true;} 
                                else {return false;}
                        } 
                        else {
                            return false;
                        }
                    }
                }
                else{
                    return true;
                }
            }
        }
}
